#!/bin/bash
method="sit"
org=""
corr=""
# for method in "sit" "ambig"
for method in "nq-table2" 
#for method in "ilm" "modality_auto" "future_auto"
#for method in "negation_auto" "poly-negation_auto"
do
		# if [[ $org = "_org" ]]
		# then
		# 	checkpoint_dir="checkpoint/adv_ex_org"
		# 	whether_org="original/"
		# 	adv="org"
		# else
		# 	checkpoint_dir="checkpoint/adv_ex_data"
		# 	whether_org=""
		# 	adv="adv"
		# fi
    if [[ $method = "sit" ]]
    then
        for topk in 25 50 75
        # for topk in "K"
        do
            for seed in "_0" "_1" "_2" "_3" "_4"
            do
                for org in ""
                do
                    if [[ $org = "_org" ]]
                    then
                        data="NQOpen_Sit_TOPK_ent_auto_org.json"
                    else
                        data="random_seed_data/NQOpen_only_corr_Sit_norm_closest_TOP${topk}_ent_auto${seed}.json"
                    fi
                    echo "method: $method topk: $topk org: $org seed: $seed" 
                    python test_reader.py \
                        --per_gpu_batch_size 1 \
                        --n_context 100 \
                        --write_results \
                        --name test_TOP${topk}_sub_sit${org}${seed} \
                        --eval_data /data/timchen0618/open_domain_data/SituatedQA/partial_sub_data/$data \
                        --model_path /data2/timchen0618/models/ODQA/FiD/pretrained_models/nq_reader_large \
                        --checkpoint_dir /data2/timchen0618/models/ODQA/FiD/pred_dir/NQOpen/SituatedQA/ \
                        --eval_print_freq 250 
                done
            done
        done
    elif [[ $method = "ambig" ]]; then
        for topk in 25 50 75
        # for topk in "K"
        do
            for seed in "_0" "_1" "_2" "_3" "_4"
            do
                for org in ""
                do
                    if [[ $org = "_org" ]]
                    then
                        data="NQOpen_only_corr_Amb_TOPK_ent_auto_org.json"
                    else
                        data="random_seed_data/NQOpen_only_corr_Amb_TOP${topk}_ent_auto${seed}.json"
                    fi
                    echo "method: $method topk: $topk org: $org seed: $seed" 
                    python test_reader.py \
                        --per_gpu_batch_size 1 \
                        --n_context 100 \
                        --write_results \
                        --name test_TOP${topk}_sub_ambig${org}${seed} \
                        --eval_data /data/timchen0618/open_domain_data/AmbigNQ/partial_sub_data/$data \
                        --model_path /data2/timchen0618/models/ODQA/FiD/pretrained_models/nq_reader_large \
                        --checkpoint_dir /data2/timchen0618/models/ODQA/FiD/pred_dir/NQOpen/AmbigQA/ \
                        --eval_print_freq 250 
                done
            done
        done
    elif [[ $method = "counter" ]]; then
        # for dataset in "AmbigQA" "SituatedQA"
        for dataset in "AmbigQA"
        do
            for split in "dev"
            do
                if [[ $dataset = "AmbigQA" ]]
                then
                    key="ambig"
                else
                    key="sit"
                fi
                echo "method: $method slpit: $split | key: $key"
                echo "data: /data/timchen0618/open_domain_data/Conflict_Data/$dataset/corr_counter_${key}_data_${split}_old.json "
                python test_reader.py \
                        --per_gpu_batch_size 1 \
                        --n_context 100 \
                        --write_results \
                        --name test_corr_counter_${key}_${split} \
                        --eval_data /data/timchen0618/open_domain_data/Conflict_Data/${dataset}/corr_counter_${key}_data_${split}_old.json \
                        --model_path /data2/timchen0618/models/ODQA/FiD/pretrained_models/nq_reader_large \
                        --checkpoint_dir /data2/timchen0618/models/ODQA/FiD/pred_dir/NQOpen/${dataset} \
                        --eval_print_freq 250 \
                        --output_generation_score \
                        --output_encoder_embed \
                        --encoder_embed_file /data/timchen0618/open_domain_data/Calibration_data/encoder_embed/embed_file_test_corr_counter_${key}_${split}_old.npy 
            done
        done
    elif [[ $method = "augment" ]]; then
        for topk in 50 75 25
        do
            seed=0
            echo "method: $method topk: $topk seed: $seed"
            python test_reader.py \
                    --per_gpu_batch_size 1 \
                    --n_context 100 \
                    --write_results \
                    --name train_augmentation_TOP${topk}_${seed} \
                    --eval_data /data/timchen0618/open_domain_data/NQ/entity_data/Augmentation/NQOpen_Train_Part_TOP${topk}_mod_ent_${seed}.json \
                    --model_path /data2/timchen0618/models/ODQA/FiD/pretrained_models/nq_reader_large \
                    --checkpoint_dir /data2/timchen0618/models/ODQA/FiD/pred_dir/NQOpen/Augmentation/ \
                    --eval_print_freq 250 \
                    --output_generation_score \
                    --output_encoder_embed \
                    --encoder_embed_file /data/timchen0618/open_domain_data/Calibration_data/encoder_embed/embed_file_train_TOP${topk}_${seed}.npy
        done
    # elif [[ $method = "ambig" ]]; then
    #     # for topk in 25 50 75
    #     for topk in "K"
    #     do
    #         for org in "_org"
    #         do
    #             echo "method: $method topk: $topk org: $org"
    #             python test_reader.py \
    #                 --per_gpu_batch_size 1 \
    #                 --n_context 100 \
    #                 --write_results \
    #                 --name test_TOP${topk}_sub_ambig${org} \
    #                 --eval_data /data/timchen0618/open_domain_data/AmbigNQ/partial_sub_data/NQOpen_Amb_TOP${topk}_ent_auto${org}.json \
    #                 --model_path /data2/timchen0618/models/ODQA/FiD/pretrained_models/nq_reader_large \
    #                 --checkpoint_dir /data2/timchen0618/models/ODQA/FiD/pred_dir/NQOpen/AmbigQA/ \
    #                 --eval_print_freq 250 \
    #                 --output_generation_score \
    #                 --output_encoder_embed \
    #                 --encoder_embed_file /data/timchen0618/open_domain_data/Calibration_data/encoder_embed/embed_file_test_TOP${topk}_sub_ambig${org}.npy 
    #         done
    #     done
    elif [[ $method = "mod_ent" ]]; then
        # for topk in 25 50 75
        for topk in "K"
        do
            seed=0
            echo "method: $method topk: $topk seed: $seed"
            python test_reader.py \
                --per_gpu_batch_size 1 \
                --n_context 100 \
                --write_results \
                --name test_TOP${topk}_mod_ent_${seed} \
                --eval_data /data/timchen0618/open_domain_data/NQ/entity_data/NQOpenPart/random_seed_data/NQOpen_Part_TOP${topk}_mod_ent_${seed}.json \
                --model_path /data2/timchen0618/models/ODQA/FiD/pretrained_models/nq_reader_large \
                --checkpoint_dir /data2/timchen0618/models/ODQA/FiD/pred_dir/NQOpen/ \
                --eval_print_freq 250 \
                --output_generation_score \
                --output_encoder_embed \
                --encoder_embed_file /data/timchen0618/open_domain_data/Calibration_data/encoder_embed/embed_file_test_TOP${topk}_mod_ent.npy 
        done
    elif [[ $method = "mod_ent_tqa" ]]; then
        for seed in 0 1 2 3 4
        # for topk in "K"
        do
            # seed=4
            topk=100
            echo "method: $method topk: $topk seed: $seed"
            python test_reader.py \
                --per_gpu_batch_size 1 \
                --n_context 100 \
                --write_results \
                --name TQA_sub_TOP${topk}_org \
                --eval_data /data/timchen0618/open_domain_data/TQA/entity_data/TQAPart/random_seed_data/TQA_Part_TOP${topk}_mod_ent_${seed}.json \
                --model_path /data2/timchen0618/models/ODQA/FiD/pretrained_models/tqa_reader_large \
                --checkpoint_dir /data2/timchen0618/models/ODQA/FiD/pred_dir/TQA/TQA_random_seed/ \
                --eval_print_freq 250 \
                --output_generation_score \
                --output_encoder_embed \
                --encoder_embed_file /data/timchen0618/open_domain_data/Calibration_data/TQA/encoder_embed/embed_file_test_TOP${topk}_mod_ent_${seed}.npy 
        done
    elif [[ $method = "tqa-table2" ]]; then
        train_ctx=50
        # for ctx in 1 $train_ctx
        for ctx in 50
        do
            split="dev"
            for seed in 3 4
            do
                echo "method: $method trained: ${train_ctx} dev: $ctx | split: $split"
                python test_reader.py \
                    --per_gpu_batch_size 1 \
                    --n_context $ctx \
                    --write_results \
                    --name dev_trained${train_ctx}_dev${ctx}ctx_sub_${seed} \
                    --model_path /data2/timchen0618/models/ODQA/FiD/trivia-checkpoint/Trivia_large_8b_${train_ctx}ctx/checkpoint/best_dev/ \
                    --eval_data /data/timchen0618/open_domain_data/TQA/entity_data/TQAPart/random_seed_data/TQA_Part_TOP100_mod_ent_all_dev_${seed}.json \
                    --checkpoint_dir /data2/timchen0618/models/ODQA/FiD/pred_dir/TQA/wholedev \
                    --eval_print_freq 5 
            done
        done
    elif [[ $method = "nq-table2" ]]; then
        train_ctx=1
        # for ctx in 1 $train_ctx
        for ctx in 1
        do
            split="dev"
            for seed in 0 1 2 3 4 
            do
                echo "method: $method trained: ${train_ctx} dev: $ctx | split: $split"
                python test_reader.py \
                    --per_gpu_batch_size 1 \
                    --n_context $ctx \
                    --write_results \
                    --name dev_trained${train_ctx}_dev${ctx}ctx_sub_${seed} \
                    --eval_data /data/timchen0618/open_domain_data/NQ/entity_data/NQOpenPart/random_seed_data/NQOpen_Part_TOP100_mod_ent_all_dev_${seed}.json \
                    --model_path /data2/timchen0618/models/ODQA/FiD/checkpoint/NQOpen_${train_ctx}ctx/checkpoint/best_dev/ \
                    --checkpoint_dir /data2/timchen0618/models/ODQA/FiD/pred_dir/NQOpen/wholedev \
                    --eval_print_freq 250                 
                    # --model_path /data2/timchen0618/models/ODQA/FiD/pretrained_models/nq_reader_large \
            done
        done
    elif [[ $method = "nq" ]]; then
        train_ctx=1
        # for ctx in 1 $train_ctx
        for ctx in 1 
        do
            split="dev"
            for seed in 0 
            do
                echo "method: $method trained: ${train_ctx} dev: $ctx | split: $split"
                python test_reader.py \
                    --per_gpu_batch_size 1 \
                    --n_context $ctx \
                    --write_results \
                    --name dev_trained${train_ctx}_dev${ctx}ctx \
                    --eval_data /data/timchen0618/open_domain_data/NQ/dev.json \
                    --model_path /data2/timchen0618/models/ODQA/FiD/checkpoint/NQOpen_${train_ctx}ctx/checkpoint/best_dev/ \
                    --checkpoint_dir /data2/timchen0618/models/ODQA/FiD/pred_dir/NQOpen/wholedev \
                    --eval_print_freq 250                 
                    # --model_path /data2/timchen0618/models/ODQA/FiD/pretrained_models/nq_reader_large \
            done
        done
    else 
        for split in "train" 
        do
            echo "method: $method split: $split"
            python test_reader.py \
                --per_gpu_batch_size 1 \
                --n_context 100 \
                --write_results \
                --name $split \
                --eval_data /data/timchen0618/open_domain_data/NQ/$split.json \
                --model_path /data2/timchen0618/models/ODQA/FiD/pretrained_models/nq_reader_large \
                --checkpoint_dir /data2/timchen0618/models/ODQA/FiD/pred_dir/NQOpen/ \
                --eval_print_freq 250 \
                --output_generation_score \
                --output_encoder_embed \
                --encoder_embed_file /data/timchen0618/open_domain_data/Calibration_data/encoder_embed/embed_file_test_$split.npy 
        done
    fi        
done
                    # --model_path /data2/timchen0618/models/ODQA/FiD/trivia-checkpoint/Trivia_large_8b_${train_ctx}ctx/checkpoint/best_dev/ \

                    # --model_path /data2/timchen0618/models/ODQA/FiD/pretrained_models/tqa_reader_large \

                    # --model_path /data2/timchen0618/models/ODQA/FiD/trivia-checkpoint/Trivia_large_8b_${train_ctx}ctx/checkpoint/best_dev \
                    # --write_crossattention_scores \
                    # --output_generation_score \
                    # --output_encoder_embed \
                    # --encoder_embed_file /data/timchen0618/open_domain_data/Calibration_data/TQA/encoder_embed/embed_file_test_$split.npy                     

            # situated --eval_data /data/timchen0618/open_domain_data/Conflict_Data/SituatedQA/counter_situated_data.json \
            # for training augmentation 
            # --eval_data /data/timchen0618/open_domain_data/NQ/entity_data/Augmentation/NQOpen_Train_Part_TOP50_mod_ent_${seed}.json \
            # --eval_data /data/timchen0618/open_domain_data/NQ/entity_data/Augmentation/NQOpen_Train_Part_TOP100_mod_ent_${seed}.json \

            #--model_path /data2/timchen0618/models/ODQA/FiD/checkpoint/NQOpen_50ctx_large/checkpoint/best_dev/  \
            #--eval_data /data/timchen0618/open_domain_data/NQ/entity_data/NQOpenPart/NQOpen_Part_only_corr_attn_TOP${topk}_mod_ent.json  \
            
            #--name NQOpen_only_corr_Amb_TOP${topk}_SHU_ent_pre${org} \
            #--eval_data /data/timchen0618/open_domain_data/AmbigNQ/partial_sub_data/NQOpen_only_corr_Amb_TOP${topk}_ent_auto${org}.json \
            #--checkpoint_dir pred_dir/AmbigQA \
            #--generation_score_file gen_prob/partial_sub/score_Amb_TOP${topk}${org}.txt \
            #--encoder_embed_file encoder_embeds/partial_sub/embed_Amb_TOP${topk}${org}.npy 
            #--output_generation_score \
            #--output_encoder_embed  \

            #--eval_data /data/timchen0618/open_domain_data/NQ/entity_data/NQOpenPart/NQOpen_Part_only_corr_TOP${topk}_mod_ent${org}.json \
            #--eval_data ../../../data/open_domain_data/NQ/dev_allcovered_corr_mod_${method}_auto.json \
            #--eval_data ../../../data/open_domain_data/NQ/dev_corr_mod_${method}_auto${org}.json \
			#--name negation_auto_trained \
        	#--model_path /data/timchen0618/models/ODQA/FiD/checkpoint/NQOpen_1ctx_large/checkpoint/best_dev/ \
            #--eval_data /data/timchen0618/open_domain_data/NQ/adv_ex_data/dev_top1_only_toppas_mod_negation_auto.json \
	        #--checkpoint_dir pred_dir/adv_ex_1ctx/ \

        	# misplaced
            #--name dev_answer_misplaced \
            #--eval_data /data/timchen0618/open_domain_data/NQ/dev_misplaced.json \
            #--checkpoint_dir pred_dir \
            #--model_path /data/timchen0618/models/ODQA/FiD/pretrained_models/nq_reader_large \
            
            # semantic change
            #--name ctx1_allcovered_${method}${org} \
            #--model_path /data/timchen0618/models/ODQA/FiD/pretrained_models/nq_reader_large \
            #--eval_data ../../../data/open_domain_data/NQ/dev_allcovered_top1_only_toppas_only_corr_mod_${method}_auto.json \


            #--model_path /data/timchen0618/models/ODQA/FiD/pretrained_models/nq_reader_large \
            #--eval_data /data/timchen0618/open_domain_data/NQ/entity_data/NQOpenPart/NQOpen_Part_sample_top_TOP${topk}_mod_ent.json \

			#--output_generation_score \
			#--output_encoder_embed \
			#--encoder_embed_file ../Calibration_qa/data/embed_file_dev_${corr}_${method}${org}.npy \
			#--generation_score_file confidence_scores/${adv}/auto/mod_dev_${method}_model_score${corr}${org}.txt \
        #--eval_data ../../../data/open_domain_data/NQ/adv_ex_data/original/dev_top1_only_toppas_mod_modality_auto_org.json  \
			#--eval_data ../../../data/open_domain_data/NQ/adv_ex_data/${whether_org}dev_top1_only_toppas${corr}_mod_${method}${org}.json  \
			#--name dev_top1${corr}_${method}${org} \
			#--eval_data /data/timchen0618/open_domain_data/NQ/adv_ex_data/${whether_org}dev_top1_only_toppas_mod_ent_auto${org}.json \
			#--model_path checkpoint/NQOpen_1ctx_large/checkpoint/best_dev/ \
            #--eval_data ../../../data/open_domain_data/NQ/entity_data/NQOpen_Dev_mod_ent_auto.json  \
            #--eval_data /data/timchen0618/open_domain_data/NQ/adv_ex_data/dev_top1_only_toppas_mod_ent_auto.json \
            #--eval_data /data/timchen0618/open_domain_data/NQ/adv_ex_data/${whether_org}dev_top1_only_toppas_mod_ent_auto${org}.json \
            
            #--eval_data ../../../data/open_domain_data/NQ/entity_data/MRQA_NQ_Dev_mod_ent_auto${org}.json   \
            #--eval_data /data/timchen0618/open_domain_data/NQ/adv_ex_data/${whether_org}dev_top1_only_toppas_mod_ent_auto${org}.json \
            #--eval_data ../../../data/open_domain_data/NQ/entity_data/NQOpen_TOP1_non_ent_swap_org.json \
            #--model_path /data/timchen0618/models/ODQA/FiD/checkpoint/NQOpen_1ctx_large/checkpoint/step-450000/ \
            #--eval_data ../../../data/open_domain_data/NQ/entity_data/MRQA_non_ent_swap_org.json   \
            #--eval_data /data/timchen0618/open_domain_data/NQ/NQOpen_Part_TOP${topk}_mod_ent.json \
            #--eval_data /data/timchen0618/open_domain_data/SituatedQA/partial_sub_data/NQOpen_Sit_norm_TOP${topk}_ent_auto.json \
