import re
import os
import sys
import json
import string
import random
from tqdm import tqdm
from sub_utils import select_random_non_identical_answer, normalize_text, _find_answer_in_context, update_context_with_substitution, find_ex_wo_entity
random.seed(42)
# dset_name = os.path.basename(args.inpath).split(".")[0]



#def select_random_non_identical_answer(ex, data):

#def normalize_text(s):

#def _find_answer_in_context(answer_text: str, context: str):

#def update_context_with_substitution(sub_answer, gold_answers, context):

#def find_ex_wo_entity(dset):

def misplace(data):
    new_data = []

    for i, inst in tqdm(enumerate(data)):
        
        gold_answers = inst['answers']
        new_contexts = []
        for c in inst['ctxs']:
            new_c = c
            print('===')
            print(c['text'])
            replace_spans = []
            for orig_answer in gold_answers:
                replace_spans.extend(
                    _find_answer_in_context(orig_answer, c['text'])
                )

            ans_spans = [c['text'][span[0] : span[1]] for span in replace_spans]
            print(ans_spans)
            ans_set = set(ans_spans)
            new_ctx = c['text']
            for a in ans_set:
                new_ctx = new_ctx.replace(a, '')
            lll = new_ctx.split(' ')
            len_ = len(lll)

            # random sample positions to insert
            rrrs = random.sample(range(0, len_), len(ans_spans))
            rrrs = sorted(rrrs, reverse=True)
            random.shuffle(ans_spans)

            # insert
            for i, s in enumerate(ans_spans):
                lll.insert(rrrs[i], s)

            new_c['text'] = ' '.join(lll)
            new_contexts.append(new_c)

        new_data.append({'question': inst['question'], 'answers': inst['answers'], 'ctxs': new_contexts})

    fw = open('new_data_1.json', 'w')
    fw.write(json.dumps(new_data, indent=4))




def use_situatedqa_on_nqpart(data, ans_and_ids, topk):
    """
        find examples without entity, and write into json format like FiD
    """

    # ans and indices - situatedqa_newans_and_idx_on_nq.json
    # dev.json

    print(len(data))
    print(len(ans_and_ids))
    new_data = []
    offsets = [0, 1]
    for i, ans_and_id in enumerate(ans_and_ids):
        # {'nq_dev_id': 50, 'answers': ['Ryan Tverberg', 'Wyatt Schingoethe'], 'question', 'edited_question'}
        print(ans_and_id)
        # substitute answer (randomly chosen)
        sub_answer = random.choice(ans_and_id['answers'])
        # retrieve example from nq
        ex = data[ans_and_id['nq_dev_id']]

        # new_contexts= []
        # for c in ex['ctxs']:
        #     new_contexts.append(update_context_with_substitution(sub_answer, ex['answers'], c['text']))
        new_data.append(ex)
        indices = ex['gold_indices']

        # handle chosen indices to substitute
        end=len(indices) * topk
        if end - int(end) > 0.5:
            end = int(end) + 1
        elif end - int(end) < 0.5:
            end = int(end)
        else:
            end = int(end) + random.choice(offsets)

        if indices and end > 0:
            chosen_indices = random.sample(indices, end)
        else:
            chosen_indices = []
        print('===')
        print(len(indices), indices)
        print(len(chosen_indices), chosen_indices)
        ######################################

        # update contexts (only on chosen indices)
        for idx in chosen_indices:
            new_data[-1]['ctxs'][idx]['text'] = update_context_with_substitution(sub_answer, ex['answers'], ex['ctxs'][idx]['text'])
        for idx in range(100):
            new_data[-1]['ctxs'][idx]['title'] = ""
            new_data[-1]['ctxs'][idx]['id'] = "0"
        
        # answer
        new_data[-1]['answers'] = [sub_answer]
        new_data[-1]['qid'] = ans_and_id['nq_dev_id']


        print('='*50)
        print('ex answer', ex['answers'])
        print('sub answer', sub_answer)
        print(ex['ctxs'][0]['text'])
        print(new_data[-1]['ctxs'][0])
    

        # new_data.append(
        #     {
        #         'question': ex['question'],
        #         'edited_question': ans_and_id['edited_question'],
        #         'ctxs': [{"id":"0", "title": "", "text": new_context} for new_context in new_contexts],
        #         'answers': [sub_answer],
        #         #'answers': ex['answers'],
        #         #'ctxs': ex['ctxs'],
        #         'qid': ans_and_id['nq_dev_id']

        #     }
        # )

    fw = open('new_data_org1.json', 'w')
    fw.write(json.dumps(new_data, indent=4))

#TODO: how do decide whether entity?


if __name__ == '__main__':
    # dset_name = sys.argv[1]
    # preprocessed_dataset = QADataset.load(dset_name)
    # find_ex_wo_entity(preprocessed_dataset)

    # data = json.load(open('/data/timchen0618/open_domain_data/NQ/dev_wgold_indices.json'))
    # ans_and_ids = json.load(open('/data/timchen0618/open_domain_data/SituatedQA/situatedqa_newans_and_idx_on_nq_norm.json'))
    # topk=float(sys.argv[1])
    # use_situatedqa_on_nqpart(data, ans_and_ids, topk)

    data = json.load(open('/data/timchen0618/open_domain_data/NQ/dev.json'))
    misplace(data)